#ifndef COMPLEXNEWTON_H
#define COMPLEXNEWTON_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include "basefrac.h"

class ComplexNewton : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int CalcPoint(int x, int y);
   virtual const int GetFracType() { return FT_COMPLEXNEWTON; }
   virtual const char* GetFracName(void) { return "Complex Newton"; }
   virtual const char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
private:
};
#endif
