#ifndef DLGJOURNEY_H
#define DLGJOURNEY_H

#include <qdialog.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qpixmap.h>
#include <qlist.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qdir.h>
#include <qfont.h>
#include <klocale.h>
#include "kmandel.h"

struct ListType {
   char File[256];  // Dateiname mit Pfad und Endung .par
   char Name[40];   // Bildname ohne Pfad und Endung
   double li,re,ob,un,Zoom,cx,cy;
   int x1,y1,x2,y2;  // fr Html
   ListType *Next,*Prev;
};

class JourneyDlg : public QDialog
{
Q_OBJECT
public:
   JourneyDlg(DrawWidget *C, QWidget* parent, const char* name);
   
signals:

private slots:
   void SuchBtnClicked();
   void DirSuchBtnClicked();
   void FertigSlot();
   void PrevSetClick();
   void FullSetClick();
   void PrevStartClick();
   void FullStartClick();
   void StopBtnClick();
   void ReadmeBtnClick();

private:
   void MakeImage(void);
   void StartJourney(int);
   int  CheckRects(ListType*);
   void DrawRects(void);
   void WriteHtml(void);
   void MakeNames(void);
   void StoreColorMap(void);
   void RestoreColorMap(void);
   void AbortJourney(void);
   
   DrawWidget *Client;
   QLineEdit *StartFileEdit, *OutDirEdit;
   QPushButton *SuchBtn, *StartBtn, *StopBtn, *CloseBtn, *DirSuchBtn;
   QPushButton *PrevSet, *FullSet, *PrevStart, *FullStart, *ReadmeBtn;
   QSpinBox *PrevXSpin, *PrevYSpin, *FullXSpin, *FullYSpin;
   QString StartFile, InDir, OutDir;
   QCheckBox *FullCheck;
   ListType *List, *Current;
   int Running;
   int Art;           // Preview oder Fullsize
   long CMap[256];       // gesicherte Farbtabelle
};

#endif
