// #include <qapp.h>
// #include <qdialog.h>
// #include <qlabel.h>
#include <stdio.h>
#include <klocale.h>
#include "dlgpicset.h"
//#include "dlgpicset.moc"

PicSetDlg::PicSetDlg(DrawWidget* Clnt, QWidget* parent, const char* name):
     QDialog (parent, name, TRUE)
{

   setFixedSize(400,350);
   setCaption("Picture-Settings");
   Client = Clnt;

   QButtonGroup* ColorGroup = new QButtonGroup(i18n("Color Deeps"), this, "ColorGroup");
   ColorGroup->setGeometry(10,10,170,100);
   ColRadio1 = new QRadioButton(i18n("1 Bit/ 2 Colors"), ColorGroup, "ColRadio1");
   ColRadio1->setGeometry(20,20,140,18);
   ColRadio2 = new QRadioButton(i18n("8 Bit/ 256 Colors"), ColorGroup, "ColRadio2");
   ColRadio2->setGeometry(20,45,140,18);
   ColRadio3 = new QRadioButton(i18n("32 Bit/TrueColor"), ColorGroup, "ColRadio3");
   ColRadio3->setGeometry(20,70,140,18);
   switch (Client->ColorDeep) {
      case  1 : ColRadio1->setChecked(TRUE);   break;
      case  8 : ColRadio2->setChecked(TRUE);   break;
      case 32 : ColRadio3->setChecked(TRUE);   break;
   }

   QGroupBox* DisplayGroup = new QGroupBox(i18n("Displaying"), this, "DisplayGoup");
   DisplayGroup->setGeometry(190,10,200,100);

   UpdateCheck = new QCheckBox(i18n("Display during calc"), DisplayGroup, "UpdateCheck");
   UpdateCheck->setGeometry(20,20,175,20);
   UpdateCheck->setChecked(Client->UpdateBool);

   IntervalEdit = new QSpinBox(DisplayGroup, "IntervalEdit");
//   IntervalEdit = new QNumericSpinBox(DisplayGroup, "IntervalEdit");
   IntervalEdit->setGeometry(20,65,80,20);
   IntervalEdit->setRange(1,2048);
   //IntervalEdit->setEditable(TRUE);
   IntervalEdit->setValue(Client->UpdateInterval);
   QLabel* UpdLabel = new QLabel(i18n("Lines per update"), DisplayGroup, "UpdLabel");
   UpdLabel->setGeometry(20,43,175,18);


   QButtonGroup* SizeGroup = new QButtonGroup(i18n("Image Size"), this, "SizeGroup");
   SizeGroup->setGeometry(10,120,380,160);
   SizeXEdit = new QSpinBox(SizeGroup, "SizeXEdit");
   SizeXEdit->setGeometry(80,20,80,20);
   SizeXEdit->setRange(4,2048);
   //SizeXEdit->setEditable(TRUE);
   SizeXEdit->setValue(Client->GetSizeX());

   SizeYEdit = new QSpinBox(SizeGroup, "SizeYEdit");
   SizeYEdit->setGeometry(270,20,80,20);
   SizeYEdit->setRange(4,2048);
   //SizeYEdit->setEditable(TRUE);
   SizeYEdit->setValue(Client->GetSizeY());

   QLabel* XLab = new QLabel(i18n("SizeX :"), SizeGroup, "XLab");
   XLab->setGeometry(30,20,35,20);
   QLabel* YLab = new QLabel(i18n("SizeY :"), SizeGroup, "YLab");
   YLab->setGeometry(230,20,35,20);


   QPushButton* S320 = new QPushButton("320*240", SizeGroup, "S320");
   S320->setGeometry(25,80,65,30);
   connect(S320, SIGNAL(clicked()), this, SLOT(S320Click()) );

   QPushButton* S500 = new QPushButton("500*375", SizeGroup, "S500");
   S500->setGeometry(90,80,65,30);
   connect(S500, SIGNAL(clicked()), this, SLOT(S500Click()) );

   QPushButton* S640 = new QPushButton("640*480", SizeGroup, "S640");
   S640->setGeometry(155,80,65,30);
   connect(S640, SIGNAL(clicked()), this, SLOT(S640Click()) );

   QPushButton* S800 = new QPushButton("800*600", SizeGroup, "S800");
   S800->setGeometry(220,80,65,30);
   connect(S800, SIGNAL(clicked()), this, SLOT(S800Click()) );

   QPushButton* S1024 = new QPushButton("1024*768", SizeGroup, "S1024");
   S1024->setGeometry(285,80,65,30);
   connect(S1024, SIGNAL(clicked()), this, SLOT(S1024Click()) );


   QPushButton* OkBtn = new QPushButton(i18n("OK"), this, "OkBtn");
   OkBtn->setGeometry(110,310,80,30);
   OkBtn->setDefault(TRUE);
   connect(OkBtn, SIGNAL(clicked()), this, SLOT(accept()) );

   QPushButton* DefaultsBtn = new QPushButton(i18n("Defaults"), this, "DefaultsBtn");
   DefaultsBtn->setGeometry(210,310,80,30);
   connect(DefaultsBtn, SIGNAL(clicked()), this, SLOT(SetDefaults()) );

   QPushButton* CancelBtn = new QPushButton(i18n("Cancel"), this, "CancelBtn");
   CancelBtn->setGeometry(310,310,80,30);
   connect(CancelBtn, SIGNAL(clicked()), this, SLOT(reject()) );
}

int PicSetDlg::SetValues(void)
{
int ColDeep;

   if (ColRadio1->isChecked())
      ColDeep=1;
   else
   if (ColRadio2->isChecked())
      ColDeep=8;
   else
      ColDeep=32;
   Client->ChangePicParams(SizeXEdit->value(),SizeYEdit->value(),ColDeep);

   if (IntervalEdit->value() > 0)
      Client->UpdateInterval = IntervalEdit->value();
   Client->UpdateBool = UpdateCheck->isChecked();

   return 1;
}

void PicSetDlg::S320Click()
{
   SizeXEdit->setValue(320);
   SizeYEdit->setValue(240);
}
void PicSetDlg::S640Click()
{
   SizeXEdit->setValue(640);
   SizeYEdit->setValue(480);
}
void PicSetDlg::S500Click()
{
   SizeXEdit->setValue(500);
   SizeYEdit->setValue(375);
}
void PicSetDlg::S800Click()
{
   SizeXEdit->setValue(800);
   SizeYEdit->setValue(600);
}
void PicSetDlg::S1024Click()
{
   SizeXEdit->setValue(1024);
   SizeYEdit->setValue(768);
}
void PicSetDlg::SetDefaults()
{
   ColRadio1->setChecked(FALSE);  // 1bpp
   ColRadio2->setChecked(TRUE);   // 8bpp
   ColRadio3->setChecked(FALSE);  //32bpp
   SizeXEdit->setValue(500);
   SizeYEdit->setValue(375);
   IntervalEdit->setValue(50);
   UpdateCheck->setChecked(TRUE);
}
